/***************************************************************************
    begin                : Wed Apr 10 2002
    copyright            : (C) 2002 by Alexei Soloviev
    email                : solovjev@lynx.jinr.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LRCD_DV_H
#define LRCD_DV_H

#include<string>

#include<TH1.h>  // ROOT class used for visualization here
#include<TH2.h>  // ROOT class used for visualization here
#include<TPad.h>  // ROOT class used for visualization here

#include"Palette.h"


class H1;
class H2;


class DV  // Distributions Viewer
{
  TH1D *hist1;
  TH2D *hist2;

  TPad *pad;

  std::string option;
  Palette grays;

 public:
  DV(const char *n1="h1", const char *n2="h2");
  ~DV();

  void associate(TPad *p);

  DV &operator<<(const H1 &h);
  DV &operator<<(const H2 &h);

  DV &operator<<(const std::string &opt);  // to set draw option
  DV &operator<<(const char *opt);  // to set draw option

  void use_palette(){ grays.use(); }
};

#endif  // LRCD_DV_H
