/***************************************************************************
    begin                : Wed Apr 10 2002
    copyright            : (C) 2002 by Alexei Soloviev
    email                : solovjev@lynx.jinr.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef LRCD_MainFrame_H
#define LRCD_MainFrame_H

#include <string>

#include <TGFrame.h>
#include <TGMenu.h>
#include <TGLabel.h>
#include <TRootEmbeddedCanvas.h>
#include <TGButton.h>
#include <TGLayout.h>

#include <TGTextEntry.h>
#include <TGSlider.h>

#include"ROD.h"
#include"DM.h"
#include"DV.h"
#include"GWT.h"


class MainFrame : public TGMainFrame
{
  ROD  rod;  // Read-Out Driver
  DM   dm;   // Distributions Maker
  DV   dv1;  // Distributions Viewer
  DV   dv2;  // Distributions Viewer
  GWT  wt;   // Gaussian Wavelet Transformer

  static const enum CommandIdentifiers{
    M_FILE_OPEN,
    M_FILE_REOPEN,
    M_FILE_SAVE_1,
    M_FILE_SAVE_2,
    M_FILE_DUMP,
    M_FILE_EXIT,

    M_OPTION_FILTER,
    M_OPTION_PICTURE_1,
    M_OPTION_PICTURE_2,

    M_TOOLS_NEXT,
    M_TOOLS_NEXT_10,
    M_TOOLS_PREV,
    M_TOOLS_PREV_10,
    M_TOOLS_ALL,

    W_NEXT,
    S_SCALE,
    SCALE
  } Comands;


  TGMenuBar           *fMenuBar;
  TGPopupMenu         *fMenuFile, *fMenuOptions, *fMenuTools;
  TGLayoutHints       *fMenuBarLayout, *fMenuBarItemLayout;

  TGCompositeFrame    *fInfoFrame;
  TGLabel             *fInfoFile, *fInfoEvent;
  TGLayoutHints       *fInfoLayout;

  TGCompositeFrame    *fWorkFrame;

  TGGroupFrame        *fWorkFrame_1;
  TRootEmbeddedCanvas *fEc1;
  TGCompositeFrame    *fOptBar_1, *fWorkBar_1;
  TGTextButton        *fPictureButton_1, *fSaveButton_1;
  TGTextButton        *fPrevButton_1, *fNextButton_1;
  TGTextButton        *fPrev10Button_1, *fNext10Button_1;

  TGGroupFrame        *fWorkFrame_2;
  TRootEmbeddedCanvas *fEc2;
  TGCompositeFrame    *fOptBar_2, *fWorkBar_2;
  TGTextButton        *fPictureButton_2, *fSaveButton_2;
  TGTextButton        *fDrawButton_2, *fEnergyButton_2, *fEWAButton_2;

   TGHSlider           *fSlider_2;
   TGTextEntry         *fScale_2;
   TGTextBuffer        *fBScale_2;
  TGTextButton        *fShowButton_2;
  TGTextButton        *fDumpButton_2;

  TGLayoutHints       *fWFLayout, *fWorkFrameLayout;

  TGCompositeFrame    *fStatusFrame;
  TGLabel             *fWarning;

 public:
  MainFrame(const TGWindow *p, UInt_t w, UInt_t h);
  virtual ~MainFrame();

  virtual void CloseWindow();
  virtual Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2);

  void draw_1();
  void draw_2(int sharp=64);
  void warn(std::string msg="");
  void info_file(std::string msg="");
  void info_event(std::string msg="");
};

#endif   // LRCD_RODMainFrame_H
