#ifndef _WSERIES_H
#define _WSERIES_H

typedef double wavereal;

#include <stdio.h>

#ifdef _USE_ROOT
#include "TObject.h"
#endif

class WSeries
#ifdef _USE_ROOT
: public TObject
#endif
{

  public:

  int      N;                   
  wavereal *data;             

 public:

  WSeries(int n);                        
  WSeries();                                
  virtual ~WSeries();                               
  WSeries& operator=(const WSeries &a);
  WSeries& operator=(const WSeries *a);
  WSeries& operator+=(const WSeries &a);
  WSeries& operator+=(const WSeries *a);
  WSeries& operator-=(const WSeries &a);
  WSeries& operator-=(const WSeries *a);
  WSeries& operator=(const wavereal c);
  WSeries& operator+=(const wavereal c);
  WSeries& operator-=(const wavereal c);
  WSeries& operator*=(const wavereal c);
  void DumpASCII(const char*, int=0);	
  void DumpBinary(const char*, int = 0);	
  void ReadBinary(const char*);
  void ReadASCII(const char*);
  void DumpShort(const char*, int=0);   	
  void ReadShort(const char*);
  virtual void Resize(int n);

#ifdef _USE_ROOT
  ClassDef(WSeries,1)                  
#endif

};
#endif
